﻿using System;
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using System.Reflection;
using System.Collections;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Collections.Specialized;
using System.Security.Cryptography.X509Certificates;
using System.Runtime.Serialization.Formatters.Binary;
using System.Timers;
using System.Net.Mail;
using System.Xml;
using System.Collections.Generic;

public sealed class AllowAllAssemblyVersionsDeserializationBinder : System.Runtime.Serialization.SerializationBinder
{
    public override Type BindToType(string assemblyName, string typeName)
    {
        Type typeToDeserialize = null;
        String currentAssembly = Assembly.GetExecutingAssembly().FullName;
        // In this case we are always using the current assembly
        assemblyName = currentAssembly;
        // Get the type using the typeName and assemblyName
        typeToDeserialize = Type.GetType(String.Format("{0}, {1}", typeName, assemblyName));
        return typeToDeserialize;
    }
}

[Serializable]
public class TID_RESULT
{
    public bool success;
    public bool FromByteArray(byte[] array)
    {
        try
        {
            if (array == null || array.Length < 1)
            {
                return false;
            }
            var formatter = new BinaryFormatter();
            formatter.Binder = new AllowAllAssemblyVersionsDeserializationBinder();
            MemoryStream ms = new MemoryStream(array);
            object obj = formatter.Deserialize(ms);
            TID_RESULT packet = (TID_RESULT)obj;
            this.success = packet.success;
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            return false;
        }
        return true;
    }

    public byte[] ToByteArray()
    {
        var formatter = new BinaryFormatter();
        using (var stream = new MemoryStream())
        {
            formatter.Serialize(stream, this);
            return stream.ToArray();
        }
    }
}

[Serializable]
public class TID_CHECK
{
    public string appid;
    public string tid;
    public string pid;
    public string nick;
    public bool FromByteArray(byte[] array)
    {
        try
        {
            if (array == null || array.Length < 1)
            {
                return false;
            }
            var formatter = new BinaryFormatter();
            formatter.Binder = new AllowAllAssemblyVersionsDeserializationBinder();
            MemoryStream ms = new MemoryStream(array);
            object obj = formatter.Deserialize(ms);
            TID_CHECK packet = (TID_CHECK)obj;
            this.appid = packet.appid;
            this.tid = packet.tid;
            this.pid = packet.pid;
            this.nick = packet.nick;
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            return false;
        }
        return true;
    }

    public byte[] ToByteArray()
    {
        var formatter = new BinaryFormatter();
        using (var stream = new MemoryStream())
        {
            formatter.Serialize(stream, this);
            return stream.ToArray();
        }
    }
}

namespace TID_Checker_Connect
{
    class Program
    {
        static void Main(string[] args)
        {
            string result = "";
            Socket m_Socket;

            string iPAdress = "169.56.70.55";   // 소프트레이어
            //string iPAdress = "192.168.0.169";
            int kPort = 11960;

            m_Socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            m_Socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 10000);
            m_Socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 10000);

            try
            {
                IPAddress ipAddr = System.Net.IPAddress.Parse(iPAdress);
                IPEndPoint ipEndPoint = new System.Net.IPEndPoint(ipAddr, kPort);
                m_Socket.Connect(ipEndPoint);

                try
                {
                    TID_CHECK check = new TID_CHECK();
                    check.pid = "0910073895";
                    check.appid = "OA00706057";
                    check.tid = "NOXTID2017041700000033";
                    check.nick = "용사";
                    byte[] data = check.ToByteArray();

                    int size = data.Length;

                    byte[] data_size = new byte[4];
                    data_size = BitConverter.GetBytes(size);
                    // 크기 전송
                    m_Socket.Send(data_size);
                    // 실 데이터 전송
                    m_Socket.Send(data);
                    m_Socket.Receive(data_size);
                    int PacketSize = BitConverter.ToInt32(data_size, 0);
                    byte[] data_result = new byte[PacketSize];
                    m_Socket.Receive(data_result);
                    TID_RESULT resultTid = new TID_RESULT();
                    resultTid.FromByteArray(data_result);
                    if(resultTid.success == true)
                    {
                        // 아이템 지급
                    } else
                    {
                        // 인증 실패
                    }
                }
                catch (SocketException err)
                {
                    Console.WriteLine("Socket send or receive error! : " + err.ToString());
                }

            }
            catch (SocketException SCE)
            {
                Console.WriteLine("Socket connect error! : " + SCE.ToString());

            }

            //=======================================================
            // Send data write.
            // 주고 받을 필요 없이 걍 받기만 하자

            m_Socket.Close();
            m_Socket = null;

            Console.WriteLine("TID : " + result);
        }
    }
}
